import { ApiService } from './../../../../../core/api/api.service';
import {ChangeDetectorRef, Component, Inject, OnInit} from '@angular/core';
import {FormBuilder, FormControl, FormGroup, Validators} from "@angular/forms";
import {MatDialog, MatDialogRef, MAT_DIALOG_DATA} from "@angular/material/dialog";

@Component({
	selector: 'kt-modal-filtros-productividad',
	templateUrl: './modal-filtros-productividad.component.html',
	styleUrls: ['./modal-filtros-productividad.component.scss']
})
export class ModalFiltrosProductividadComponent implements OnInit {

	form: FormGroup;
	loading: boolean = false;
	sucursales = null;
	usuarios = [];
	origenes = null;
	startDate = null;

	filtroDefinio = [
		{id: '1', nombre: 'Definió cliente'},
		{id: '2', nombre: 'Definió atención a clientes'}
	];

	addDays = (date: Date, days: number): Date => {
		let result = new Date(date);
		result.setDate(result.getDate() + days);
		return result;
	};

	constructor(private fb: FormBuilder,
				public dialog: MatDialog,
				public dialogRef: MatDialogRef<ModalFiltrosProductividadComponent>,
				private api: ApiService,
				private cdr: ChangeDetectorRef,
				@Inject(MAT_DIALOG_DATA) public data: any) {

		this.initLoginForm();
		this.filtros();
	}

	ngOnInit() {}

	initLoginForm() {
		let fechaInicio = this.data? this.addDays(new Date(this.data.fecha_inicio+'T00:00:00.000Z'), 1) : null;
		let fechaFinal = this.data? this.addDays(new Date(this.data.fecha_final+'T00:00:00.000Z'), 1) : null;
		let sucursal = this.data? this.data.sucursal : null;
		let definio = this.data? this.data.definio : 0;
		let usuario_id = this.data? this.data.usuario_id : null;

		this.form = this.fb.group({
			sucursal: new FormControl({value: sucursal, disabled: true}, [Validators.required]),
			definio: new FormControl({value: definio, disabled: false}, [Validators.required]),
			fecha_inicio: new FormControl({value: fechaInicio, disabled: false}, [Validators.required]),
			fecha_final: new FormControl({value: fechaFinal, disabled: false}, [Validators.required]),
			usuario_id: new FormControl({value: usuario_id, disabled: true}, [Validators.required]),
		});
	}

	setFilters(){
		let data = this.form.value;
		data.fecha_inicio = new Date(data.fecha_inicio).toLocaleDateString('en-CA');
		data.fecha_final = new Date(data.fecha_final).toLocaleDateString('en-CA');

		let user = this.searchUserById(data.usuario_id);
		data.user = user.nombre + ' ' + user.apellido_paterno + ' ' + user.apellido_materno;

		this.dialogRef.close(data);
	}

	filtros(){
		this.loading = true;
		this.api.reportesService.filtros('sucursales').subscribe(res => {
			this.form.controls['sucursal'].enable();

			this.sucursales = res.data;

			if(this.data)
				this.getUsers(true);

			this.loading = false;
		}, () => {
			this.loading = false;
		});
	}

	dateChanged(dateModal: any){
		if(dateModal){
			this.startDate = this.form.value.fecha_inicio;
			this.form.get('fecha_final').reset();
			dateModal.open();
		}

		this.getUsers();
	}

	getUsers(reOpen = false){
		let sucursal = this.form.value.sucursal;
		let definio = this.form.value.definio;
		let fechaInicio = this.form.value.fecha_inicio;
		let fechaFinal = this.form.value.fecha_final;

		if(sucursal && definio != null && fechaInicio && fechaFinal){
			this.changeStatusInputs(false);
			this.loading = true;
			this.usuarios = [];

			if(!reOpen)
				this.form.get('usuario_id').reset();

			let data = this.form.value;
			data.fecha_inicio = new Date(data.fecha_inicio).toLocaleDateString('en-CA');
			data.fecha_final = new Date(data.fecha_final).toLocaleDateString('en-CA');

			this.api.reportesService.getInformation('productividad/atencionclientes/usuarios', data).subscribe(res => {
				this.usuarios = res.data;
				this.changeStatusInputs(true);
				this.loading = false;
				this.cdr.detectChanges();
			}, () => {
				this.changeStatusInputs(true);
				this.loading = false;
			});
		}
	}

	changeStatusInputs(enable){
		if(enable){
			this.form.controls['sucursal'].enable();
			this.form.controls['definio'].enable();
			this.form.controls['fecha_inicio'].enable();
			this.form.controls['fecha_final'].enable();
			this.form.controls['usuario_id'].enable();
		}else{
			this.form.controls['sucursal'].disable();
			this.form.controls['definio'].disable();
			this.form.controls['fecha_inicio'].disable();
			this.form.controls['fecha_final'].disable();
			this.form.controls['usuario_id'].disable();
		}
	}

	searchUserById(valor){
		let index = this.usuarios.findIndex((user => valor == user.id));
		if(index != -1){
			return this.usuarios[index];
		}
		return false;
	}
}
